package com.zhongzheng.modules.inform.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.inform.bo.InformRemindBusinessAddBo;
import com.zhongzheng.modules.inform.bo.InformRemindBusinessQueryBo;
import com.zhongzheng.modules.inform.bo.InformRemindBusinessEditBo;
import com.zhongzheng.modules.inform.domain.InformRemindBusiness;
import com.zhongzheng.modules.inform.mapper.InformRemindBusinessMapper;
import com.zhongzheng.modules.inform.vo.InformRemindBusinessVo;
import com.zhongzheng.modules.inform.service.IInformRemindBusinessService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 提醒设置绑定业务Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-30
 */
@Service
public class InformRemindBusinessServiceImpl extends ServiceImpl<InformRemindBusinessMapper, InformRemindBusiness> implements IInformRemindBusinessService {

    @Override
    public InformRemindBusinessVo queryById(Long id){
        InformRemindBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, InformRemindBusinessVo.class);
    }

    @Override
    public List<InformRemindBusinessVo> queryList(InformRemindBusinessQueryBo bo) {
        LambdaQueryWrapper<InformRemindBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getRemindId() != null, InformRemindBusiness::getRemindId, bo.getRemindId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<InformRemindBusinessVo> entity2Vo(Collection<InformRemindBusiness> collection) {
        List<InformRemindBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, InformRemindBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<InformRemindBusiness> page = (Page<InformRemindBusiness>)collection;
            Page<InformRemindBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(InformRemindBusinessAddBo bo) {
        InformRemindBusiness add = BeanUtil.toBean(bo, InformRemindBusiness.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(InformRemindBusinessEditBo bo) {
        InformRemindBusiness update = BeanUtil.toBean(bo, InformRemindBusiness.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(InformRemindBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<InformRemindBusinessVo> selectBusiness(Long id) {
        return baseMapper.selectBusiness(id);
    }
}
